SystemOrganization addCategory: #'GT-Debugger'!
SystemOrganization addCategory: 'GT-Debugger-Actions'!
SystemOrganization addCategory: 'GT-Debugger-Tests'!

Trait named: #GTBrowsingActions
	uses: {}
	category: 'GT-Debugger-Actions'!

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:01'!
browseClassRefs

	self currentContext ifNotNil: [ :aContext || class|
		class := aContext methodClass theNonMetaClass.
		class isTrait 
			ifTrue: [ self systemNavigation browseAllUsersOfTrait: class ]
			ifFalse: [ self systemNavigation browseAllCallsOnClass: class ] ]
! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:01'!
browseClassVarRefs
	"1/17/96 sw: devolve responsibility to the class, so that the code that does the real work can be shared"

	| cls |
	cls := self currentClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation  browseClassVarRefs: cls]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:01'!
browseClassVariables
	"Browse the class variables of the selected class."
	| cls |
	cls := self currentClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation  browseClassVariables: cls]
! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:00'!
browseInstVarRefs
	"1/26/96 sw: real work moved to class, so it can be shared"
	| cls |
	cls := self currentClassOrMetaClass.
	(cls notNil and: [cls isTrait not])
		ifTrue: [self systemNavigation browseInstVarRefs: cls]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 17:59'!
browseMessages
	"Present a menu of all messages sent by the current message. 
	Open a message set browser of all implementors of the message chosen."

	self currentMessageName ifNotNil: [   
		self systemNavigation browseAllImplementorsOf: self currentMessageName ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:02'!
browseMethodFull
	"Create and schedule a full Browser and then select the current class and message."

	self currentClassOrMetaClass ifNotNil: [ 
		Smalltalk tools browser 
			fullOnClass: self currentClassOrMetaClass
			selector: self currentMessageName ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 17:58'!
browseSendersOfMessages
	"Present a menu of the current message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self currentMessageName ifNotNil: [   
		self systemNavigation browseAllSendersOf: self currentMessageName ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:00'!
browseVersions
	"Create and schedule a message set browser on all versions of the 
	currently selected message selector."

	| class selector |
	class := self currentClassOrMetaClass.
	selector := self currentMessageName.
	Smalltalk tools versionBrowser
		browseVersionsOf: (class compiledMethodAt: selector)
		class: self currentClass theNonMetaClass
		meta: class isMeta
		category: self currentMessageCategoryName
		selector: selector! !

!GTBrowsingActions methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 18:03'!
currentClass

	^ self currentContext methodClass! !

!GTBrowsingActions methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 18:03'!
currentClassOrMetaClass

	^ self currentContext classOrMetaClass! !

!GTBrowsingActions methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 18:03'!
currentContext
	
	^ self debugger currentContext! !

!GTBrowsingActions methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 18:03'!
currentMessageCategoryName
	"Answer the name of the message category of the message of the currently selected context."

	^ self currentClass organization categoryOfElement: self currentMessageName! !

!GTBrowsingActions methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 18:04'!
currentMessageName

	^ self currentContext messageName! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:02'!
fileOutMessage
	"Put a description of the selected message on a file"

	self currentMessageName ifNotNil: [
		Cursor write showWhile:
			[ self currentClassOrMetaClass fileOutMethod: self currentMessageName ] ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:02'!
inspectInstances
	"Inspect all instances of the selected class."

	self currentClassOrMetaClass ifNotNil: [ :aClass |
		aClass theNonMetaClass inspectAllInstances ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 18:02'!
inspectSubInstances
	"Inspect all instances of the selected class and all its subclasses"

	self currentClassOrMetaClass ifNotNil: [ :aClass |
		aClass theNonMetaClass inspectSubInstances ]! !

!GTBrowsingActions methodsFor: 'actions' stamp: 'AndreiChis 4/16/2014 17:59'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self systemNavigation 
			methodHierarchyBrowserForClass: self currentClassOrMetaClass 
			selector: self currentMessageName
! !

!StepIntoDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/17/2014 23:05'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousInto! !

WhereIsDebugAction subclass: #GTWhereIsDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTWhereIsDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 11/13/2013 23:40'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousSearch! !

!GTWhereIsDebugAction methodsFor: 'actions' stamp: 'AndreiChis 11/13/2013 23:39'!
executeAction

	self debugger updateSelectionInterval! !

!GTWhereIsDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 23:39'!
id

	^ #gtWhereIs! !

!DebugContext methodsFor: '*gt-debugger' stamp: 'VincentBlondeau 2/14/2014 16:47'!
gtDebuggerRetrieveVariableValuePairs
	| fieldList |
	fieldList := OrderedCollection new.
	fieldList
		add: '_self' -> context receiver;
		addAll: (context receiver class allInstVarNames collect: [ :each | each -> (context receiver instVarNamed: each) ]).
	fieldList add: '_thisContext' -> context.
	context == nil
		ifTrue: [ ^ fieldList ].
	fieldList
		add:
			'_stack top'
				->
					(context stackPtr > 0
						ifTrue: [ context top ]).
	context tempNames notEmpty
		ifTrue: [ 
			fieldList
				addAll:
					((1 to: context tempNames size)
						collect: [ :index | 
							| key value |
							key := context tempNames at: index.
							value := [ context debuggerMap namedTempAt: index in: context ]
								on: Error
								do: [ value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
							key -> value ]) ].
	^ fieldList! !

!ContextPart methodsFor: '*gt-debugger' stamp: 'AndreiChis 12/4/2013 12:21'!
findContextMatchingPredicate: aPredicate
	^ self findContextSuchThat: [ :ctx |
		aPredicate matches: ctx ]! !

!ContextPart methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:20'!
isHaltContext

	^ self method selector = #halt! !

!FuelOutStackDebugAction class methodsFor: '*GT-Debugger-Actions' stamp: 'AndreiChis 9/12/2014 15:00'!
gtActionFor: aDebugger
	<gtStackDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			order: 30! !

!DoesNotUnderstandDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:47'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAdd! !

!InstructionStream methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/29/2013 20:29'!
isInitialnstruction

	^ self pc = self method initialPC! !

!DebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 12/16/2013 16:14'!
asGlamourAction

	^ ((GLMGenericAction new) 
			action: [ self execute ]; 
			icon: self icon;
			title: self label;
			shortcut: (self keyText ifNotNil: [:aString | aString at: 1]);
			category: self category;
			yourself)! !

DebugAction subclass: #GTBrowseMethodDebuggerAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTBrowseMethodDebuggerAction class methodsFor: 'registration' stamp: 'TudorGirba 11/16/2013 08:24'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousBrowse! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:15'!
defaultLabel

	^ 'Browse'! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:13'!
defaultOrder

	^ 200! !

!GTBrowseMethodDebuggerAction methodsFor: 'actions' stamp: 'AndreiChis 12/6/2013 17:51'!
executeAction
	Smalltalk tools browser 
	fullOnClass: self debugger selectedContext methodClass
 	selector: self debugger selectedContext selector! !

!GTBrowseMethodDebuggerAction methodsFor: 'accessing' stamp: 'TudorGirba 11/16/2013 08:14'!
id

	^ #gtBrowseMethodDebuggerAction! !

!GTBrowseMethodDebuggerAction methodsFor: 'actions' stamp: 'AndreiChis 12/6/2013 17:52'!
initialize
	self needsUpdate: false! !

DebugAction subclass: #GTClearEditorDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTClearEditorDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 4/17/2014 00:18'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
		icon: GLMUIThemeExtraIcons glamorousCancel! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 16:08'!
defaultIcon

	^ nil
	"^ Smalltalk ui icons smallCancelIcon"! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 16:01'!
defaultKeyText

	^ 'l'! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 15:59'!
defaultLabel

	^ 'Cancel'! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 15:59'!
defaultOrder

	^ 10! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 16:04'!
executeAction

	(self confirm:
'This action will cancel your changes.
Is it OK to cancel changes?' translated) ifTrue: [ self debugger updateBrowser]! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 15:59'!
id

	^ #gtClearEditorDebugAction! !

!GTClearEditorDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/16/2013 16:03'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTDebugSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTDebugSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/6/2014 15:23'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:40'!
defaultKeyText

	^ nil
	"^ 'D'"! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:21'!
defaultLabel

	^ 'Debug it'! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:22'!
defaultOrder

	^ 20! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:22'!
executeAction
	
	self debugger codePresentation debugSelection
		
! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:22'!
id

	^ #gTDebugSelectionDebugAction! !

!GTDebugSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:21'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTExecuteSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTExecuteSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/6/2014 15:23'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousSpawn! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 00:27'!
defaultKeyText

	^ 'd'! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 00:28'!
defaultLabel

	^ 'Do it'! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:07'!
defaultOrder

	^ 15! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:18'!
executeAction
	
	self debugger codePresentation evaluateSelection
		
! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 00:27'!
id

	^ #gTExecuteSelectionDebugAction! !

!GTExecuteSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 00:27'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTInspectSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTInspectSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/6/2014 15:23'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousInspect! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 10:23'!
defaultKeyText

	^ 'i'! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 10:24'!
defaultLabel

	^ 'Inspect it'! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:09'!
defaultOrder

	^ 15! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:17'!
executeAction
	
	self debugger codePresentation evaluateSelectionAndDo: [ :result | result inspect ]
		
! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 10:23'!
id

	^ #gTInspectSelectionDebugAction! !

!GTInspectSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 4/17/2014 10:22'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTOpenSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTOpenSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/5/2014 18:36'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/5/2014 11:51'!
defaultKeyText

	^ 'o'! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/5/2014 12:00'!
defaultLabel

	^ 'Open it'! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 14:47'!
defaultOrder

	^ 5! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:20'!
executeAction
	
	self debugger codePresentation evaluateSelectionAndDo: [ :result | self debugger inspect: result ] 
		
! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/5/2014 11:51'!
id

	^ #gTOpenSelectionDebugAction! !

!GTOpenSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/5/2014 11:51'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTPrintSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTPrintSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/7/2014 11:05'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
		! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:05'!
defaultKeyText

	^ 'p'! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:05'!
defaultLabel

	^ 'Print it'! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:07'!
defaultOrder

	^ 10! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:05'!
executeAction
	
	self debugger codePresentation printSelection
		
! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:05'!
id

	^ #gTPrintSelectionDebugAction! !

!GTPrintSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:04'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTProfileSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTProfileSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 5/6/2014 15:26'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)! !

!GTProfileSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:26'!
defaultLabel

	^ 'Profile it'! !

!GTProfileSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/7/2014 11:07'!
defaultOrder

	^ 30! !

!GTProfileSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:27'!
executeAction
	
	self debugger codePresentation profileSelection
		
! !

!GTProfileSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:27'!
id

	^ #gTProfileSelectionDebugAction! !

!GTProfileSelectionDebugAction methodsFor: 'as yet unclassified' stamp: 'AndreiChis 5/6/2014 15:26'!
initialize

	self needsUpdate: false! !

DebugAction subclass: #GTSaveDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTSaveDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 12/16/2013 18:52'!
gtActionFor: aDebugger
	<gtCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAccept! !

!GTSaveDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 5/6/2014 17:46'!
defaultKeyText

	^ 's'! !

!GTSaveDebugAction methodsFor: 'initialization' stamp: 'AndreiChis 8/30/2013 14:42'!
defaultLabel

	^ 'Accept'! !

!GTSaveDebugAction methodsFor: 'initialization' stamp: 'AndreiChis 8/30/2013 14:42'!
defaultOrder

	^ 5! !

!GTSaveDebugAction methodsFor: 'actions' stamp: 'AndreiChis 7/7/2014 10:16'!
executeAction

	self needsUpdate: false.
	self debugger codePresentation 
		compileTextIn: self currentContext from: self session andDo: [ self needsUpdate: true ]

	"self session 
		recompileMethodTo: sourceCode 
		inContext: self currentContext 
		notifying: self debugger codePresentation"! !

DebugAction subclass: #GTTemporaryPreDebugChangeDebuggerAction
	instanceVariableNames: 'preDebugWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTTemporaryPreDebugChangeDebuggerAction class methodsFor: 'registration' stamp: 'AndreiChis 11/13/2013 23:09'!
actionType
	<preDebuggingAction>! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultLabel

	^ 'Debug Glamorously'! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultOrder

	^ 200! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'actions' stamp: 'AndreiChis 12/17/2013 11:24'!
executeAction
	| currentDebugger currentSession |
	
	"Close the spec PreDebugWindow and debugger"
	currentDebugger := self preDebugWindow debugger.
	self preDebugWindow debugger: nil.
	self preDebugWindow close.
	currentSession := currentDebugger session.
	currentDebugger session: nil.
	currentDebugger clear. "clear not close, as at this point there is no open window to close"
	
	GTGenericStackDebugger debugSession: currentSession! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
id

	^ #gtChangeDebuggerPreDebug! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow
	
	^ preDebugWindow! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow: anObject
	
	preDebugWindow := anObject! !

BrowseDebugAction subclass: #GTBrowseDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTBrowseDebugAction class methodsFor: 'actions creation' stamp: 'AndreiChis 4/16/2014 18:08'!
gtDebugActionsFor: aDebugger
	<gtContextDebuggingAction>
	
	^ super debugActionsFor: aDebugger! !

!GTBrowseDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 4/16/2014 17:54'!
receiver

	^ self debugger! !

!ToggleBreakDebugAction class methodsFor: '*GT-Debugger-Actions' stamp: 'AndreiChis 4/16/2014 17:44'!
gtActionType
	<gtContextDebuggingAction>! !

!CopyToClipboardDebugAction class methodsFor: '*GT-Debugger-Actions' stamp: 'AndreiChis 9/12/2014 15:16'!
gtActionFor: aDebugger
	<gtStackDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			order: 35! !

!StepThroughDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/17/2014 23:05'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousThrough! !

!ReturnValueDebugAction class methodsFor: '*GT-Debugger-Actions' stamp: 'AndreiChis 4/16/2014 17:42'!
gtActionType
	<gtContextDebuggingAction>! !

!PeelToFirstDebugAction class methodsFor: '*GT-Debugger-Actions' stamp: 'AndreiChis 4/16/2014 17:40'!
gtActionType
	<gtContextDebuggingAction>! !

!StepOverDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/17/2014 23:05'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousOver! !

!RestartDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/17/2014 23:05'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousRestart! !

!Process methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext
	"Resume self until the top context safisfy the given condition."

	| ctxt  |
	
	ctxt := aContext.
	[ 
		ctxt notNil and: [aPredicate matches: ctxt]
	] whileFalse: [
		ctxt := self step: ctxt.
	].
	^ ctxt! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:40'!
createPredicateForBlock: aBlock 

	^ BlockContextPredicate for: aBlock! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:17'!
createStepPredicateForBlock: aBlock 

	^ self createStepPredicatForPredicate: (self createPredicatForBlock: aBlock)
			! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 16:46'!
createStepPredicateForPredicate: aPredicate
	" Subclasses should specialize this method if needed. "
	^ aPredicate! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:22'!
createStepPredicateForPredicate: aPredicate fromContext: targetContext

	^ (self createPredicateForBlock: [ :currentContext |
		(self isActive: targetContext) not or: [ currentContext isHaltContext ] ]) 
			or: aPredicate
	! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:21'!
isActive: aContext

	^ true! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext 
	| ctxt |
	
	ctxt := self process stepUntil: (self createStepPredicateForPredicate: aPredicate) from: aContext.
	self  
		updateWithContext: ctxt 
		fromProcess: self process.! !

!MethodContext methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/13/2014 14:32'!
gtConstructDebuggerInspectorIn: composite
	
	^composite custom: ((GTDebuggerInspector new  
		showFirst: [ :a | a custom: (GTDebuggerVariablesBrowser new startOn: self)];
		yourself) 
			startOn: self)! !

!MethodContext methodsFor: '*GT-Debugger' stamp: 'VincentBlondeau 2/14/2014 16:52'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList context|

	fieldList := OrderedCollection new.
	context := self.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames notEmpty) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

!MethodContext methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/20/2014 20:24'!
reservedNames

	^ #( '_self' '_thisContext' '_stack top')! !

!ChangeDebuggerAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 9/12/2014 15:16'!
gtChangeDebuggerActionsFor: aDebugger
	<gtDebuggingAction>
	
	^ self 
		changeDebuggerActionsForContext: aDebugger interruptedContext 
		excluding: aDebugger! !

GLMCompositePresentation subclass: #GTDebuggerVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerVariablesBrowser commentStamp: 'TudorGirba 11/2/2012 22:06' prior: 0!
GTDebuggerVariablesBrowser is a special browser that is used in the first pane of the inspector that is embedded in the debugger. Its main intention is to provide a unified list of variables that come from:
- the instance variables of the receiver
- the local variables from the context!

!GTDebuggerVariablesBrowser methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/13/2014 14:30'!
compareVariableTypeOf: x withVariable: y in: aContext

	^ (self variableTypeOf: x in: aContext) < (self variableTypeOf: y in: aContext)! !

!GTDebuggerVariablesBrowser methodsFor: 'building' stamp: 'AndreiChis 12/29/2013 16:40'!
compose  
	"self title: [:each | GTInspector new printObjectAsAnItem: each receiver ]."
	"self morphicAct: [:anotherComposite | anotherComposite entity receiver browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'."
	self tabulator with: [:browser | 
		browser row: #variables.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 6/13/2014 14:09'!
tagsForVariable: aString from: aContext
	^ (aContext reservedNames includes: aString) 
		ifTrue: [ #() ]
		ifFalse: [ self variableTypeOf: aString in: aContext ]
			
	! !

!GTDebuggerVariablesBrowser methodsFor: 'as yet unclassified' stamp: 'AndreiChis 6/13/2014 14:08'!
variableTypeOf: aString in: aContext
	^ (aContext receiver class hasInstVarNamed: aString)
			ifTrue: [ 'attribute' ]
			ifFalse: [ (aContext method argumentNames includes: aString)
				ifTrue: [ 'parameter' ]
				ifFalse: [ 'temp' ] ]
			
	! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 6/13/2014 14:29'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :context | context gtDebuggerRetrieveVariableValuePairs ];
		sorted: [:variablePair1 :variablePair2 | variablePair1 key < variablePair2 key];
		column: 'Type'
			evaluated: [ '' ]
			width: 75
			tags: [ :assoc :context |
				self tagsForVariable: assoc key from: context ]
			sortedBy: [ :x :y | 
				self 
					compareVariableTypeOf: x key
					withVariable: y key
					in: ((self presentations first paneNamed: #variables) port: #entity) value];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
					on: Error
					do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
					on: Error
					do: [ Text string: 'error printing' attribute: TextColor red ] ];
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect'! !

GLMCompositePresentation subclass: #GTMoldableDebugger
	uses: GTBrowsingActions
	instanceVariableNames: ''
	classVariableNames: 'EnableDebuggerWindowDistinctColor'
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTMoldableDebugger commentStamp: '<historical>' prior: 0!
GTMoldableDebugger provides the basic functionality needed to create new debuggers. 
Subclasses should override the following methods:
	debuggerStructureIn: -> provides the structure of the debugger
	debuggerTransmissionsIn: -> creates transmissions between the widgets of a debuggers
	selectedContext !

GTMoldableDebugger class
	uses: GTBrowsingActions classTrait
	instanceVariableNames: ''!

GTMoldableDebugger subclass: #GTGenericStackDebugger
	instanceVariableNames: ''
	classVariableNames: 'AlwaysOpenFullDebugger EnableStackColoring ErrorRecursion FilterCommonMessageSends LogDebuggerStackToFile LogFileName'
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTGenericStackDebugger commentStamp: '<historical>' prior: 0!
GTGenericStackDebugger is a browser that provides Smalltalk debugging functionality.
 !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
alwaysOpenFullDebugger
	^ AlwaysOpenFullDebugger ifNil: [AlwaysOpenFullDebugger := false]! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
alwaysOpenFullDebugger: aBoolean
	AlwaysOpenFullDebugger := aBoolean.! !

!GTGenericStackDebugger class methodsFor: 'utilities api' stamp: 'AndreiChis 12/17/2013 11:23'!
closeAllDebuggers
	"GTGenericStackDebugger closeAllDebuggers"
	(SystemWindow allSubInstances select: [:w | 
		 w model isKindOf: GTGenericStackDebugger])
			do: [:w | w delete ]! !

!GTGenericStackDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 12/16/2013 16:37'!
context: aContext
	"Answer an instance of me for debugging the active process starting with the given context."

	^ self new
		process: Processor activeProcess
		controller: nil
		context: aContext
		! !

!GTGenericStackDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 12/16/2013 16:37'!
debugError: anError
	"Handle an otherwise unhandled error"

	self
		openOn: Processor activeProcess
		context: anError signalerContext
		label: anError description
		contents: nil
		fullView: false! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
defaultLogFileName
	^ 'PharoDebug.log'! !

!GTGenericStackDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/29/2013 17:12'!
defaultTitle
	^ 'Default Debugger'! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/18/2013 23:17'!
enableStackColoring
	^ EnableStackColoring ifNil: [EnableStackColoring := false]! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/18/2013 23:16'!
enableStackColoring: aBoolean
	EnableStackColoring := aBoolean.! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
filterCommonMessageSends
	self flag: 'horrible hack not to break the setting browser'.
	^ false! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
filterCommonMessageSends: aBoolean
	FilterCommonMessageSends := aBoolean! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 1/3/2014 18:19'!
filterDoItSelectors
	^ false! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 1/3/2014 18:19'!
filterKernelClasses
	^ false! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 1/3/2014 18:20'!
filterNilSelectors
	^ false! !

!GTGenericStackDebugger class methodsFor: 'testing' stamp: 'AndreiChis 12/16/2013 16:37'!
handlesContext: aContext

	^ true! !

!GTGenericStackDebugger class methodsFor: 'instance creation api' stamp: 'AndreiChis 12/16/2013 16:37'!
informExistingDebugger: aContext label: aString
	"Walking the context chain, we try to find out if we're in a debugger stepping situation.
	If we find the relevant contexts, we must rearrange them so they look just like they would
	if the methods were excuted outside of the debugger."
	| ctx quickStepMethod oldSender baseContext |
	ctx := thisContext.
	quickStepMethod := ContextPart compiledMethodAt: #quickSend:to:with:super:.
	[ctx sender == nil or: [ctx sender method == quickStepMethod]] whileFalse: [ctx := ctx sender].
	ctx sender == nil ifTrue: [^self].
	baseContext := ctx.
	"baseContext is now the context created by the #quickSend... method."
	oldSender := ctx := ctx sender home sender.
	"oldSender is the context which originally sent the #quickSend... method"
	[ctx isNil or: [ctx receiver isKindOf: self]] whileFalse: [ctx := ctx sender].
	ctx ifNil: [^self].
	"ctx is the context of the Debugger method #doStep" self flag: 'this is not true any more'.
	ctx receiver label: aString.
	baseContext swapSender: baseContext sender sender sender.	"remove intervening contexts"
	thisContext swapSender: oldSender.	"make myself return to debugger"
	ErrorRecursion := false.
	^aContext! !

!GTGenericStackDebugger class methodsFor: 'initialization' stamp: 'AndreiChis 12/16/2013 16:37'!
initialize 
	
	ErrorRecursion := false.! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
logDebuggerStackToFile
	^ LogDebuggerStackToFile ifNil: [LogDebuggerStackToFile := true]! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
logDebuggerStackToFile: aBoolean
	 LogDebuggerStackToFile := aBoolean! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
logFileName
	^ LogFileName ifNil: [ self defaultLogFileName ] ! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
logFileName: newName
	LogFileName := newName! !

!GTGenericStackDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 12/16/2013 16:37'!
openContext: aContext label: aString contents: contentsStringOrNil
	"Open a notifier in response to an error, halt, or notify. A notifier view just shows a short view of the sender stack and provides a menu that lets the user open a full debugger."
	
	<primitive: 19> "Simulation guard"
	ErrorRecursion not & self logDebuggerStackToFile ifTrue:
		[Smalltalk logError: aString inContext: aContext].
	  ErrorRecursion ifTrue:[
               ErrorRecursion := false.
               self primitiveError: aString].
	ErrorRecursion := true.
	
	self informExistingDebugger: aContext label: aString.
	(self context: aContext)
		openNotifierContents: contentsStringOrNil
		label: aString.
	ErrorRecursion := false. 
	Processor activeProcess suspend.
! !

!GTGenericStackDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 12/16/2013 16:37'!
openInterrupt: aString onProcess: interruptedProcess 
	"Open a notifier in response to an interrupt. An interrupt occurs when
	the user types the interrupt key (cmd-. on Macs, ctrl-c or alt-. on other
	systems) or when the low-space watcher detects that memory is low."
	| debugger |
	<primitive: 19>
	"Simulation guard"
	debugger := self new.
	debugger
		process: interruptedProcess
		controller: nil
		context: interruptedProcess suspendedContext.
	self logDebuggerStackToFile
		ifTrue: [(aString includesSubstring: 'Space')
					& (aString includesSubstring: 'low')
				ifTrue: [Smalltalk
						logError: aString
						inContext: debugger interruptedContext ]].
	^ debugger openNotifierContents: nil label: aString! !

!GTGenericStackDebugger class methodsFor: 'opening api' stamp: 'AndreiChis 12/16/2013 16:37'!
openOn: process context: context label: title contents: contentsStringOrNil fullView: bool 
	"Open a notifier in response to an error, halt, or notify. A notifier view
	just shows a short view of the sender stack and provides a menu that
	lets the user open a full debugger."
	| fullView |
	fullView := (bool or: [self alwaysOpenFullDebugger]).
	
	Smalltalk tools userManager canDebug ifFalse: [ 
		UIManager default spawnNewProcessIfThisIsUI: process.
		process suspend.
		^ self ].
	
	^ UIManager default 
		openDebuggerOn: process 
		context: context 
		label: title 
		contents: contentsStringOrNil 
		fullView: fullView! !

!GTGenericStackDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/31/2013 21:01'!
register

	self registerToolsOn: Smalltalk tools.
	self registerExtraToolsOn: Smalltalk tools.
! !

!GTGenericStackDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/16/2013 16:37'!
registerExtraToolsOn: registry
	"This adds self in the list of tools that appears in the small debugger"
	registry registerDebugger: self withRank: 3.! !

!GTGenericStackDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/16/2013 16:37'!
registerToolsOn: registry
	registry register: self as: #debugger.
! !

!GTGenericStackDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:37'!
sessionClass

	^ DebugSession ! !

!GTGenericStackDebugger class methodsFor: 'settings api' stamp: 'AndreiChis 12/16/2013 16:37'!
stackWidgetClass
	self flag: 'horrible hack not to break the setting browser'.
	^ self! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:37'!
codeActionsPragmas

	^ #( codeDebuggingAction )! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 4/17/2014 00:36'!
codePane

	^ self browser paneNamed: #code! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 4/17/2014 10:26'!
codePresentation
	
	^ self codePane presentations first! !

!GTGenericStackDebugger methodsFor: 'building' stamp: 'AndreiChis 12/16/2013 17:03'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code span: 2 ]
			span: 2;
		row: #inspector.
		! !

!GTGenericStackDebugger methodsFor: 'building' stamp: 'AndreiChis 12/18/2013 18:00'!
debuggerTransmissionsIn: browser

	browser transmit
		fromOutsideEntityPort;
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		from: #stack port: #entity;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session context].
	browser transmit "need a method call when the selection is changed"
		from: #stack port: #selection;
		to: #stack port: #action;
		transformed: [ :context | 
			self selectionChanged: context ].
	browser transmit
		from: #stack port: #selection;
		to: #code;
		andShow: [ :composite :aContext | self methodCodeIn: composite forContext: aContext ].
	browser transmit
		from: #stack port: #selection;
		to: #inspector;
		andShow: [ :composite | self inspectorIn: composite ] 
! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:37'!
debuggingActionsPragmas

	^ #( debuggingAction )! !

!GTGenericStackDebugger methodsFor: 'old api' stamp: 'AndreiChis 12/16/2013 16:37'!
errorWasInUIProcess: aBoolean

	self session errorWasInUIProcess: aBoolean! !

!GTGenericStackDebugger methodsFor: 'printing/formatting' stamp: 'AndreiChis 12/17/2013 11:32'!
formatStackEntry: aContext

	^ Text 
		string: (self printStackEntry: aContext )
		attributes: (self textAttributesForStackEntry: aContext) 
	 ! !

!GTGenericStackDebugger methodsFor: 'actions' stamp: 'AndreiChis 5/5/2014 18:30'!
inspect: anObject

	((self browser paneNamed: #inspector) port: #entity) value: anObject.
	(self browser paneNamed: #inspector) update.
	! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/20/2014 16:01'!
inspectorIn: aComposite

	^ aComposite dynamic 
		display: [:anObject |
			self inspectorIn: GLMCompositePresentation new on: anObject ]! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 5/5/2014 18:31'!
inspectorIn: aComposite on: anObject
				
	^ anObject gtConstructDebuggerInspectorIn: aComposite
	
	! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:37'!
installCodeActionsFor: aPresentation
	
	self installActionsForRootPragmas: self codeActionsPragmas in: aPresentation! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:37'!
installDebuggingActionsFor: aPresentation

	self installActionsForRootPragmas: self debuggingActionsPragmas in: aPresentation! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 9/12/2014 14:56'!
installStackDebuggingActionsFor: aPresentation

	self installActionsForRootPragmas: self stackDebuggingActionsPragmas in: aPresentation! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/16/2013 16:37'!
methodCodeIn: composite forContext: aContext

	(self methodCodeWidgetIn: composite forContext: aContext)
		initialize: [ :code | 
			code selectionInterval: (self session selectedCodeRangeForContext: self currentContext) ];
		with: [ :code | self installCodeActionsFor: code ]! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 12/16/2013 16:37'!
methodCodeWidgetIn: composite forContext: aContext

	^ composite smalltalkCode
		title: 'Source';
		format: [ aContext sourceCode ];
		smalltalkClass: [  aContext methodClass ];
		doItReceiver: [ aContext receiver ];
		doItContext: [  aContext ]! !

!GTGenericStackDebugger methodsFor: 'opening' stamp: 'AndreiChis 12/17/2013 10:17'!
openFullNoSuspendLabel: aString
	"TODO: do not ignore the title"
	
	(self title: aString) open.
	"If the debugger is opened as a result of a notification directly from the UI, span another process."
	self errorWasInUIProcess: (UIManager default spawnNewProcessIfThisIsUI: self session interruptedProcess)! !

!GTGenericStackDebugger methodsFor: 'opening' stamp: 'AndreiChis 12/16/2013 16:37'!
openNotifierContents: msgString label: label
	self openFullNoSuspendLabel: label! !

!GTGenericStackDebugger methodsFor: 'printing/formatting' stamp: 'AndreiChis 12/16/2013 16:37'!
printStackEntry: aContext

	^ String streamContents: [:stream | aContext printDebugOn: stream ] ! !

!GTGenericStackDebugger methodsFor: 'old api' stamp: 'AndreiChis 12/16/2013 16:37'!
proceed: aTopView 
	
	self session 
		resume;
		clear.
	self debugger close.
	self updateBrowser
! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/21/2014 12:27'!
retrieveStackFrom: aSession

	^ aSession stack
		! !

!GTGenericStackDebugger methodsFor: 'updating' stamp: 'AndreiChis 4/18/2014 16:08'!
selectTopContext
	((self browser paneNamed: #stack) port: #selection) value: self interruptedContext! !

!GTGenericStackDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 12/16/2013 16:37'!
selectedContext

	^ ((self browser paneNamed: #stack) port: #selection) value! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 4/17/2014 00:42'!
selectedText

	^ (self codePane port: #selectedText) value! !

!GTGenericStackDebugger methodsFor: 'updating' stamp: 'AndreiChis 12/18/2013 23:21'!
selectionChanged: aContext
	
	self class enableStackColoring ifTrue: [  
		UIManager default defer: [
			(self browser paneNamed: #stack) presentations  presentations ifNotEmpty: [ :p | 
				p first update ] ] ]! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:37'!
selectionInterval

	^ self selectionIntervalForPane: #code! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:37'!
selectionInterval: anInterval

	^ ((self browser paneNamed: #code) port: #selectionInterval) value: anInterval! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:37'!
selectionIntervalForPane: aSymbol

	^ ((self browser paneNamed: aSymbol) port: #selectionInterval) value ifNil: [ ^ 1 to: 0 ]! !

!GTGenericStackDebugger methodsFor: 'old api' stamp: 'AndreiChis 12/16/2013 16:37'!
send
	
	self session stepInto: self currentContext.
	self updateBrowser.
! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:37'!
sourceCode: aString

	^ ((self browser paneNamed: #code) port: #text) value: aString! !

!GTGenericStackDebugger methodsFor: 'building actions' stamp: 'AndreiChis 9/12/2014 14:56'!
stackDebuggingActionsPragmas

	^ #( stackDebuggingAction )! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/12/2014 14:55'!
stackIn: composite

	(self stackWidgetIn: composite)
		with: [ :stackWidget | self installStackDebuggingActionsFor: stackWidget ]! !

!GTGenericStackDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/21/2014 12:27'!
stackWidgetIn: composite

	^ composite list	
		title: 'Stack';
		showOnly: 50;
		display: [:aSession | self retrieveStackFrom: aSession];
		format: [ :each | self formatStackEntry: each]! !

!GTGenericStackDebugger methodsFor: 'printing/formatting' stamp: 'AndreiChis 12/18/2013 23:22'!
textAttributesForStackEntry: aContext

	(self selectedContext isNil or: self class enableStackColoring not) ifTrue: [ ^ {TextColor black} ].

	(self selectedContext == aContext) ifTrue: [ ^ {TextColor black}  ].

	(aContext receiver class = self selectedContext receiver class)
		ifTrue: [ ^ { TextColor blue } ].
	(aContext receiver class package = self selectedContext receiver class package)
		ifTrue: [ ^ { TextColor black } ]. 

	^ {TextColor gray}! !

!GTGenericStackDebugger methodsFor: 'updating' stamp: 'AndreiChis 12/16/2013 16:37'!
updateSelectionInterval

	self selectionInterval: (self session pcRangeForContext:  self selectedContext )! !

!GTGenericStackDebugger methodsFor: 'accessing' stamp: 'AndreiChis 8/16/2014 12:25'!
window
	"The default debugger from Pharo defines this method.
	Some tools use it and break. Try to return the window
	if possible. Kind of a hack."
	^ self dependents ifNotNil: [ :dependentsArray |
		dependentsArray ifNotEmpty: [ 
			(dependentsArray at: 1) isSystemWindow
				ifTrue: [ dependentsArray at: 1 ]
				ifFalse: [ nil ] ] ]! !

!GTMoldableDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 12/16/2013 16:39'!
debugBasedOnSession: aSession

	^ self debugSession: ((self spanNewSessionForContext: aSession context fromProcess: aSession process)
		errorWasInUIProcess: aSession errorWasInUIProcess)! !

!GTMoldableDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 12/16/2013 16:39'!
debugContext: aContext fromProcess: aProcess

	^ self debugSession: (self spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTMoldableDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 12/16/2013 16:39'!
debugSession: aSession

	<primitive: 19> "simulation guard"

	"WorldState addDeferredUIMessage: ["
		^ self openOn: aSession 
	"]"! !

!GTMoldableDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:38'!
defaultTitle
	self subclassResponsability! !

!GTMoldableDebugger class methodsFor: 'settings api' stamp: 'TudorGirba 2/11/2014 06:35'!
enableDebuggerWindowDistinctColor
	^ EnableDebuggerWindowDistinctColor ifNil: [EnableDebuggerWindowDistinctColor := false]! !

!GTMoldableDebugger class methodsFor: 'settings api' stamp: 'TudorGirba 2/11/2014 06:35'!
enableDebuggerWindowDistinctColor: aBoolean
	EnableDebuggerWindowDistinctColor := aBoolean.! !

!GTMoldableDebugger class methodsFor: 'testing' stamp: 'AndreiChis 12/16/2013 16:40'!
handlesContext: aContext
	self subclassResponsibility ! !

!GTMoldableDebugger class methodsFor: 'opening' stamp: 'AndreiChis 12/16/2013 16:39'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTMoldableDebugger class methodsFor: 'window color api' stamp: 'AndreiChis 12/16/2013 16:41'!
patchworkUIThemeColor
	"Answer a default color for UI themes that make use of different colors for Browser, MessageList etc..."

	^ Color lightRed
! !

!GTMoldableDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:39'!
sessionClass
	self subclassResponsability! !

!GTMoldableDebugger class methodsFor: 'private' stamp: 'AndreiChis 12/16/2013 16:40'!
spanNewSessionForContext: aContext fromProcess: aProcess

	^ self sessionClass process: aProcess context: aContext ! !

!GTMoldableDebugger class methodsFor: 'icons' stamp: 'AndreiChis 4/16/2014 18:28'!
taskbarIcon

	^ Smalltalk ui icons smallDebugIcon! !

!GTMoldableDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 12/16/2013 16:47'!
actOnBrowserClosing: ann
	self session ifNotNil: [ :aSession | aSession terminate ]! !

!GTMoldableDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:46'!
actionsForPragmas: aSymbolsCollection

	^ (self allActionsForPragmas: aSymbolsCollection)
				collect: [ :aDebugAction | aDebugAction asGlamourAction ]
! !

!GTMoldableDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 17:25'!
allActionsForPragmas: aSymbolsCollection
	
	^ (self session class 
		debuggingActionsForPragmas: aSymbolsCollection 
		for: self)

	
! !

!GTMoldableDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:45'!
browser 

	^ self presentations first! !

!GTMoldableDebugger methodsFor: 'actions' stamp: 'AndreiChis 12/16/2013 16:46'!
close

	self browser close! !

!GTMoldableDebugger methodsFor: 'building' stamp: 'AndreiChis 9/12/2014 14:50'!
compose
	"give the window a dedicated reddish color to ensure it gets noticed"
	self class enableDebuggerWindowDistinctColor ifTrue: [ 
		self color: (Color r: 1.0 g: 0.3 b: 0.3) ].
	self installDebuggingActionsFor: self.
	self tabulator with: [:browser | 
		self debuggerStructureIn: browser.
		self debuggerTransmissionsIn: browser ].
	self registerActions! !

!GTMoldableDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 12/16/2013 16:58'!
currentContext

	^self selectedContext 
		ifNil: [ self interruptedContext ] 
		ifNotNil:  [ self selectedContext  ]! !

!GTMoldableDebugger methodsFor: 'actions' stamp: 'AndreiChis 12/16/2013 16:46'!
debug: aContext using: aDebuggerClass
	| currentSession  |
	
	currentSession := self session.
	self detachSession.
	self browser close.
	currentSession updateContextTo: aContext.
	aDebuggerClass debugBasedOnSession: currentSession! !

!GTMoldableDebugger methodsFor: 'building' stamp: 'AndreiChis 12/16/2013 17:03'!
debuggerStructureIn: browser
	self subclassResponsability
		! !

!GTMoldableDebugger methodsFor: 'building' stamp: 'AndreiChis 12/16/2013 17:07'!
debuggerTransmissionsIn: browser
	self subclassResponsibility ! !

!GTMoldableDebugger methodsFor: 'actions' stamp: 'AndreiChis 12/16/2013 16:46'!
detachSession
	self flag: 'why silent value?'.
	(self browser pane port: #entity) silentValue: nil! !

!GTMoldableDebugger methodsFor: 'protocol' stamp: 'AndreiChis 4/16/2014 23:00'!
initialExtent
"This code was taken from the standard debugger to get the same behavior. Fell free to refactor"

	RealEstateAgent standardWindowExtent y < 400 "a tiny screen" 
		ifTrue: [^ 700@500].
	
	^ [ | w h |
		w := Display width.
		h := Display height.
		(w - (w // 3)) @ (h - (h // 5)) ]
		on: Error
		do: [ 850@600 ]! !

!GTMoldableDebugger methodsFor: 'building actions' stamp: 'AndreiChis 12/16/2013 16:46'!
installActionsForRootPragmas: aSymbolsCollection in: aPresentation

	aPresentation dynamicActions: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gt, aSymbol capitalized ]) ] .
	
	aPresentation dynamicActionsOnSelection: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gtContext, aSymbol capitalized ]) ] .! !

!GTMoldableDebugger methodsFor: 'building actions' stamp: 'AndreiChis 9/12/2014 14:48'!
installDebuggingActionsFor: aPresentation

	self subclassResponsibility! !

!GTMoldableDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 12/16/2013 17:04'!
interruptedContext

	^ self session context! !

!GTMoldableDebugger methodsFor: 'accessing' stamp: 'AndreiChis 1/21/2014 15:28'!
interruptedProcess

	^ self session interruptedProcess! !

!GTMoldableDebugger methodsFor: 'scripting opening' stamp: 'AndreiChis 4/16/2014 22:59'!
openOn: anObject 
	^ (super openOn: anObject)
		extent: self initialExtent;
		yourself! !

!GTMoldableDebugger methodsFor: 'intialization' stamp: 'AndreiChis 12/16/2013 16:47'!
process: aProcess controller: aController context: aContext

	self session: (self class spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTMoldableDebugger methodsFor: 'building' stamp: 'AndreiChis 12/16/2013 16:52'!
registerActions

	self on: GLMBrowserClosing send: #actOnBrowserClosing: to: self.
	self on: DebugActionExecuted send: #updateBrowser to: self.
! !

!GTMoldableDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 12/16/2013 17:05'!
selectedContext
	self subclassResponsibility ! !

!GTMoldableDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:45'!
session
 
	^ (self browser pane port: #entity) value! !

!GTMoldableDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 16:45'!
session: anObject

	^ (self browser pane port: #entity) value: anObject! !

!GTMoldableDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 10:11'!
title
	
	^ super title 
		ifNil: [ self class defaultTitle ] 
		ifNotNil: [ :aString | aString ] ! !

!GTMoldableDebugger methodsFor: 'updating' stamp: 'AndreiChis 12/16/2013 16:47'!
updateBrowser
	| browserPane session |
	
	session := self session.
	browserPane := self browser pane.
	(browserPane port: #entity) silentValue: nil.
	(browserPane port: #entity) value: session.
	browserPane update.! !

!GTMoldableDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 12/16/2013 16:47'!
windowIsClosing 
	self announce: GLMBrowserClosing new! !

RunToSelectionDebugAction subclass: #GTRunToSelectionDebugAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Actions'!

!GTRunToSelectionDebugAction class methodsFor: 'registration' stamp: 'AndreiChis 4/17/2014 00:15'!
gtActionFor: aDebugger
	<gtContextCodeDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousPlay! !

!GTRunToSelectionDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 5/6/2014 15:24'!
defaultOrder

	^ 1! !

!GTRunToSelectionDebugAction methodsFor: 'actions' stamp: 'AndreiChis 12/16/2013 15:32'!
executeAction

	self session 
		runToSelection: self debugger selectionInterval
		inContext: self currentContext! !

!GTRunToSelectionDebugAction methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 15:29'!
id

	^ #gtRunToSelection! !

!RunToSelectionDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:46'!
gtActionFor: aDebugger
	"<gtCodeDebuggingAction>"
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousPlay! !

GTInspector subclass: #GTDebuggerInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerInspector commentStamp: 'TudorGirba 3/25/2014 11:03' prior: 0!
This is a specialized inspector that is embedded in the GTDebugger.

It is special in two ways:
- the first presentation is different in that it shows all variables active in the debugging context
- the looking up of presentation ignores the default state presentation because the vertical splitting of state and workspace does not work in the context of the debugger due to space limitations. Instead, the workspace is offered in a separate presentation.!

!GTDebuggerInspector methodsFor: 'building' stamp: 'TudorGirba 6/17/2014 07:46'!
compose
	self pager show: [ :a :each | 
			a dynamic display: [ :x | 
				GLMCompositePresentation new with: [:d | each gtDebuggerPresentationsIn: d inContext: self ] ] ]! !

TestCase subclass: #GTDebuggerSmokeTest
	instanceVariableNames: 'session window debugger'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Tests'!

!GTDebuggerSmokeTest class methodsFor: 'testing' stamp: 'AndreiChis 12/17/2013 10:00'!
isAbstract
	^ self name = #GTDebuggerSmokeTest! !

!GTDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 19:17'!
debuggerToTest
	self subclassResponsability! !

!GTDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 19:17'!
instantiateSession
	self subclassResponsability! !

!GTDebuggerSmokeTest methodsFor: 'running' stamp: 'AndreiChis 12/17/2013 15:14'!
setUp
	session := self instantiateSession.
	debugger := self debuggerToTest new.! !

!GTDebuggerSmokeTest methodsFor: 'running' stamp: 'AndreiChis 12/16/2013 19:24'!
tearDown 
	debugger close! !

!GTDebuggerSmokeTest methodsFor: 'tests' stamp: 'AndreiChis 12/17/2013 15:44'!
testDebugger

	self assert: (debugger class handlesContext: session interruptedContext). 

	window := debugger openOn: session.
	
	self assert: window model equals: debugger.
	self assert: debugger session interruptedContext notNil.
	self assert: debugger session interruptedProcess notNil.
	
 	debugger close.

	self assert: window model equals: nil.
	self assert: debugger session interruptedContext equals: nil.
	self assert: debugger session interruptedProcess equals: nil.! !

GTDebuggerSmokeTest subclass: #GTGenericStackDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Tests'!

!GTGenericStackDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 11:24'!
debuggerToTest

	^ GTGenericStackDebugger! !

!GTGenericStackDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/16/2013 19:16'!
instantiateSession
	| context process |
	context := [ 20 factorial ] asContext.

	process := Process 
		forContext: context
		priority: Processor userInterruptPriority.
		
	^ self debuggerToTest spanNewSessionForContext: context fromProcess: process! !

GTDebuggerSmokeTest subclass: #GTGlamourDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Tests'!

!GTGlamourDebuggerSmokeTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/19/2013 16:09'!
debuggerToTest

	^ GTGlamourDebugger! !

!GTGlamourDebuggerSmokeTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/19/2013 16:11'!
instantiateSession
	| initialContext process |
	initialContext := [GLMBasicExamples open] asContext.
	process := Process 
		forContext: initialContext
		priority: Processor userInterruptPriority.
		
	self stepToGlamourModelConstructionInProcess: process.	
	^ self debuggerToTest spanNewSessionForContext: process suspendedContext fromProcess: process! !

!GTGlamourDebuggerSmokeTest methodsFor: 'as yet unclassified' stamp: 'AndreiChis 12/19/2013 16:26'!
stepToGlamourModelConstructionInProcess: aProcess

	aProcess
		step;
		step;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step; "send openOn:"
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step; "send openOn:with:"
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step "send startOn:"! !

GTDebuggerSmokeTest subclass: #GTPPDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger-Tests'!

!GTPPDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 15:20'!
debuggerToTest

	^ GTPPDebugger! !

!GTPPDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 8/28/2014 12:00'!
expectedFailures
	^ #(testDebugger)! !

!GTPPDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/17/2013 15:40'!
instantiateSession
	| initialContext process |
	initialContext := [ PPArithmeticParser new parse: '1+1'] asContext.
	process := Process 
		forContext: initialContext
		priority: Processor userInterruptPriority.
		
	self stepToWhenParsingStartsInProcess: process.	
	^ self debuggerToTest spanNewSessionForContext: process suspendedContext fromProcess: process! !

!GTPPDebuggerSmokeTest methodsFor: 'private' stamp: 'AndreiChis 12/17/2013 15:39'!
stepToWhenParsingStartsInProcess: aProcess
	"Step through the execution until the process reaches a context 
	that can be handles using the PetitParser debugger"
	
	aProcess 
		step;
		step;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step;
		step;
		step; "send the message 'parse:' "
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step. "send the message parseOn: "
	aProcess stepToSendOrReturn! !

!ResumeDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 4/17/2014 23:05'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousPlay! !

!SubclassResponsabilityDebugAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 11/13/2013 23:48'!
gtActionFor: aDebugger
	<gtDebuggingAction>
	
	^ (self forDebugger: aDebugger)
			icon: GLMUIThemeExtraIcons glamorousAdd! !

Object subclass: #GTDebuggerSystemSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerSystemSettings class methodsFor: 'as yet unclassified' stamp: 'TudorGirba 2/11/2014 06:36'!
debugSettingsOn: aBuilder
	<systemsettings>
	
	(aBuilder setting: #enableStackColoring)
		label: 'Color the stack' translated;
		target: GTGenericStackDebugger;
		parent: #debugging;
		description:
				'When true, the stack context are colored based on their relationship with the selected context.' translated.
	
	(aBuilder setting: #enableDebuggerWindowDistinctColor)
		label: 'Color the window' translated;
		target: GTGenericStackDebugger;
		parent: #debugging;
		description:
				'When true, the window border is colored with red to make it distinct from other windows.' translated.
	
! !

!Object methodsFor: '*gt-debugger' stamp: 'AndreiChis 5/5/2014 18:41'!
gtConstructDebuggerInspectorIn: composite
	
	^ composite custom: (GTDebuggerInspector new startOn: self)! !

!Object methodsFor: '*gt-debugger' stamp: 'AndreiChis 12/29/2013 18:25'!
gtDebuggerEvaluatorIn: composite
	<gtDebuggerPresentationOrder: 15>
	
	(GTObjectVariablesBrowser new evaluatorIn: composite)
		title: 'Evaluator'! !

!Object methodsFor: '*gt-debugger' stamp: 'AndreiChis 9/8/2014 10:43'!
gtDebuggerPresentationsIn: composite inContext: aGTInspector
	| pragmas |
	pragmas := (Pragma 
				allNamed: #gtDebuggerPresentationOrder: 
				from: self class 
				to: Object) asOrderedCollection.
	pragmas addAll:((Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object)
					reject: [:pragma| pragma method selector = #gtInspectorStateIn: ]).
	pragmas := pragmas sorted: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		(eachPragma selector findTokens: $:) size = 1 
			ifTrue: [ self perform: eachPragma selector with: composite ]. 
		(eachPragma selector findTokens: $:) size = 2
			ifTrue: [ self perform: eachPragma selector with: composite with: aGTInspector ] ]
! !

!Object methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/4/2014 22:08'!
gtDebuggerStateIn: composite
	<gtDebuggerPresentationOrder: 10>
	
	(GTObjectVariablesBrowser new variablesIn: composite)
		title: 'State';
		send: #value! !
GTGenericStackDebugger initialize!
